﻿/**
  @page QSPI_MemoryMappedDual QSPI memory mapped dual mode example
  
  @verbatim
  ******************** (C) COPYRIGHT 2019 STMicroelectronics *******************
  * @file    QSPI/QSPI_MemoryMappedDual/readme.txt
  * @author  MCD Application Team
  * @brief   Description of the QSPI memory mapped dual mode example.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  @endverbatim

@par Example Description

This example describes how to erase part of the QSPI memory, write data in IT mode and access to QSPI memory 
in memory-mapped dual mode to check the data in a forever loop.

The SystemClock_Config() function is used to set the Flash latency and  to configure the system clock :
  - The Cortex-M7 at 400MHz 
  - Cortex-M4 at 200MHz.
  - The HCLK for D1 Domain AXI/AHB3 peripherals , D2 Domain AHB1/AHB2 peripherals 
    and D3 Domain AHB4  peripherals at 200MHz.
  - The APB clock dividers for D1 Domain APB3 peripherals, D2 Domain APB1/APB2 peripherals 
    and D3 Domain APB4 peripherals to run at 100MHz.

CPU1 (Cortex-M7) and CPU2 (Cortex-M4) are booting at once (with respect to configured boot Flash options)
System Init, System clock, voltage scaling and L1-Cache configuration are done by CPU1 (Cortex-M7).
In the meantime Domain D2 is put in STOP mode (CPU2: Cortex-M4 in deep sleep mode) to save power consumption.
When system initialization is finished, CPU1 (Cortex-M7) could release CPU2 (Cortex-M4) when needed
by means of HSEM notification or by any D2 Domain wakeup source (SEV,EXTI..).

The above will guarantee that CPU2 (Cortex-M4) code execution starts after system initialization :
(system clock config, external memory configuration..).

After Domain D2 wakeup, if  CPU1 attempts to use any resource from such a domain, 
the access will not be safe until “clock ready flag” of such a domain is set (by hardware). 
The check could be done using this macro : __HAL_RCC_GET_FLAG(RCC_FLAG_D2CKRDY).

This example uses the QSPI memory in dual mode. You may need to power Off/Power On the board after flashing 
this example if the previous setting of the QSPI memory is single mode.

LED1 toggles each time the data have been checked
LED2 is on as soon as a data is wrong
LED2 is on as soon as an error is returned by HAL API

@note For Cortex-M7, Some code parts (for instance ISR routines, vector table, critical routines )
      can be executed from the ITCM-RAM (64 KB) allowing zero wait state access.
      Which decreases critical task execution time compared to code execution from internal Flash memory. 
      This configuratuion can be done using '#pragma location = ".itcmram"' to be placed above function declaration, 
      or using the toolchain GUI (file options) to execute a whole source file in the ITCM-RAM.
      For fast data access, critical variables, application RAM, heap, stack could be put as well in the DTCM-RAM (128 KB). 

@Note For the Cortex-M7, if the application is using the DTCM/ITCM memories (@0x20000000/ 0x0000000: not cacheable and only accessible
      by the Cortex-M7 and the  MDMA), no need for cache maintenance when the Cortex M7 and the MDMA access these RAMs.
      If the application needs to use DMA(or other masters) based access or requires more RAM, then  the user has to:
              - Use a non TCM SRAM. (example : D1 AXI-SRAM @ 0x24000000)
              - Add a cache maintenance mechanism to ensure the cache coherence between CPU and other masters(DMAs,DMA2D,LTDC,MDMA).
              - The addresses and the size of cacheable buffers (shared between CPU and other masters)
                must be properly defined to be aligned to L1-CACHE line size (32 bytes). 
 
@Note It is recommended to enable the cache and maintain its coherence.
      Depending on the use case it is also possible to configure the cache attributes using the MPU.
      Please refer to the AN4838 "Managing memory protection unit (MPU) in STM32 MCUs"
      Please refer to the AN4839 "Level 1 cache on STM32F7 Series"      
	  
@note Care must be taken when using HAL_Delay(), this function provides accurate delay (in milliseconds)
      based on variable incremented in SysTick ISR. This implies that if HAL_Delay() is called from
      a peripheral ISR process, then the SysTick interrupt must have higher priority (numerically lower)
      than the peripheral interrupt. Otherwise the caller ISR process will be blocked.
      To change the SysTick interrupt priority you have to use HAL_NVIC_SetPriority() function.
      
@note The example need to ensure that the SysTick time base is always set to 1 millisecond
      to have correct HAL operation.

@par Directory contents
  
    - QSPI/QSPI_MemoryMappedDual/CM7/Inc/main.h                Main configuration file for Cortex-M7
    - QSPI/QSPI_MemoryMappedDual/CM7/Inc/stm32h7xx_it.h        Interrupt handlers header file for Cortex-M7
    - QSPI/QSPI_MemoryMappedDual/CM7/Inc/stm32h7xx_hal_conf.h  HAL configuration file for Cortex-M7
    - QSPI/QSPI_MemoryMappedDual/CM7/Src/main.c                Main program  for Cortex-M7
    - QSPI/QSPI_MemoryMappedDual/CM7/Src/stm32h7xx_it.c        Interrupt handlers for Cortex-M7
    - QSPI/QSPI_MemoryMappedDual/CM7/Src/stm32h7xx_hal_msp.c   HAL MSP module for Cortex-M7

    - QSPI/QSPI_MemoryMappedDual/CM4/Inc/main.h                Main configuration file for Cortex-M4
    - QSPI/QSPI_MemoryMappedDual/CM4/Inc/stm32h7xx_it.h        Interrupt handlers header file for Cortex-M4
    - QSPI/QSPI_MemoryMappedDual/CM4/Inc/stm32h7xx_hal_conf.h  HAL configuration file for Cortex-M4
    - QSPI/QSPI_MemoryMappedDual/CM4/Src/main.c                Main program  for Cortex-M4
    - QSPI/QSPI_MemoryMappedDual/CM4/Src/stm32h7xx_it.c        Interrupt handlers for Cortex-M4
    - QSPI/QSPI_MemoryMappedDual/CM4/Src/stm32h7xx_hal_msp.c   HAL MSP module for Cortex-M4
	
@par Hardware and Software environment  

  - This example runs on STM32H745xx devices.
  
  - This example has been tested with STM32H745I-DISCO board with SMPS (SD Convertor) power supply config and can be
    easily tailored to any other supported device and development board.

@par How to use it ?

In order to make the program work, you must do the following :
 - Open your preferred toolchain 
 - For each target configuartion (STM32H745I_DISCO_CM7 and STM32H745I_DISCO_CM4) : 
     - Rebuild all files 
     - Load images into target memory
 - Run the example
                          
 * <h3><center>&copy; COPYRIGHT STMicroelectronics</center></h3>
 */
                                   